//M200 Intervention By Pandan
//Original Script base by Tc572

datablock AudioProfile(M200fire)
{
   filename    = "./weaponfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(m200clip)
{
   filename    = "./clipout.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(m200boltpull)
{
   filename    = "./boltpull.wav";
   description = AudioClose3d;
   preload = true;
};
//
//


if($ammo::default["m200"]$="")$ammo::default["m200"]=10;

datablock DebrisData(m200ShellDebris)
{
	shapeFile = "add-ons/weapon_gun/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(m200FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.8;
	sizes[1]      = 1.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(m200FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "m200FlashParticle";


};


datablock ParticleData(m200ImpactSmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "./particleTest";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(m200ImpactSmoke)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "m200ImpactSmokeParticle";
   lifetimeMS       = 50;
};


datablock ExplosionData(m200Explosion)
{
	soundProfile = bulletHitSound;

   emitter[0] = m200ImpactSmoke;
   faceViewer           = false;
};



datablock ProjectileData(m200Projectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 51;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 500;
   verticalImpulse	  = 0;
   explosion           = m200Explosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};


//////////
// item //
//////////
datablock ItemData(m200Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./m200.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Intervention";
	iconName = "./m200";
	doColorShift = false;
	colorShiftColor = "0.6 0.6 0.6 1.000";

	 // Dynamic properties defined by the scripts
	image = m200Image;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(m200Image)
{

   // Basic Item properties
   shapeFile = "./m200.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = m200Projectile;
   projectileType = Projectile;

	casing = m200ShellDebris;
	shellExitDir        = "1.0 -1.3 2.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.6 0.6 0.6 1.000";

   minShotTime = 815;

   //casing = " ";
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateSequence[0]                = "ready";
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponswitchsound;

	stateName[1]                     = "Ready";
	stateSequence[1]		= "Ready";
	statescript[1]			="checkammo";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.15;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= m200FlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= m200fire;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.005;
	statetransitionOnNoAmmo[3]      = "reload";
	stateTransitionOnTimeout[3]     = "Cock";

//If you laughed at this, you are now gay. Good job.
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

	stateName[4] = "Cock";
	stateTimeoutValue[4]            = 0.800;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;
	stateSequence[4]	 = "bolt";
	stateTransitionOnTimeOut[4]     = "Ready";
	stateSound[4]					= m200boltpull;
	stateEjectShell[4]       = true;

	stateName[5]			= "reload";
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]			= true;
	stateTimeoutValue[5]            = 0.5;
	stateSequence[5]	= "clipout";
	stateSound[5]					= m200clipout;
	stateTransitionOnTimeout[5]     = "Empty";

	stateName[6]			= "Empty";
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateTimeoutValue[6]            = 0.8;
	stateSequence[6]	= "empty";
	stateTransitionOnTimeout[6]     = "Clipin";
	
	stateName[7]			= "Clipin";
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateTimeoutValue[7]            = 0.5;
	stateSequence[7]	= "clipin";
	stateSound[7]					= m200clipin;
	stateTransitionOnTimeout[7]     = "Boltpull";

	stateName[8]			= "Boltpull";
	stateAllowImageChange[8]        = false;
	stateWaitForTimeout[8]		= true;
	stateTimeoutValue[8]            = 0.4;
	stateSequence[8]	= "bolt";
	statescript[8]            = "onreload";
	stateSound[8]					= m200boltpull;
	stateTransitionOnTimeout[8]     = "Ready";

};
function m200Image::onfire(%this,%obj,%slot)
{
	%player = %obj;
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["m200"]@"/10");
    if(!%obj.ammo["m200"]){%obj.setimageammo(%slot,0);
	return;
	}
	if(vectorLen(%player.getVelocity()) <= 0.1)
	{
	    %obj.setimageammo(%slot,1);
		%obj.ammo["m200"]-=1;
	
		%projectile = m200projectile;
		%spread = 0.0001;
		%shellcount = 1;
	



		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		}
		else
		{
		%obj.setimageammo(%slot,1);
		%obj.ammo["m200"]-=1;
	
		%projectile = m200projectile;
		%spread = 0.016;
		%shellcount = 1;
	



			for(%shell=0; %shell<%shellcount; %shell++)
			{
				%vector = %obj.getMuzzleVector(%slot);
				%objectVelocity = %obj.getVelocity();
				%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
				%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
				%velocity = VectorAdd(%vector1,%vector2);
				%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
	}
	return %p;

}
function m200Image::onreload(%this, %obj, %slot)
{
    if(%obj.ammo["m200"]$=0)
	%obj.ammo["m200"]=10;
    if(%obj.ammount$="")
	%obj.ammount=0;
	    %obj.ammo["m200"]+=%obj.ammount;
		echo("reload?");
		    centerPrint(%obj.client, "<just:right>0/10");
}
function m200Image::checkammo(%this,%obj,%slot)
{
    if(%obj.ammo["m200"]$="")%obj.ammo["m200"]=$ammo::default["m200"];
    if(%obj.ammo["m200"])%obj.setimageammo(%slot,1);
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["m200"]@"/10");
}

function m200Projectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   //echo("Called!");

   if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
   {
      if(%col.getClassName() $= "AIPlayer")
      {
         %oClient = %col.client;
         %col.client = BotConnection;
         %hitbox = getHitbox(%obj,%col,%pos);
         %col.client = %oClient;
      }
      else
      {
	%hitbox = getHitbox(%obj,%col,%pos);
      }
      if(strstr(%hitbox, "headskin") > -1)
      {
	 //echo("Headshot");
	 %obj.client.play2D(rewardSound);
	 %obj.client.centerPrint("\c3HEADSHOT",3);
	 echo(%obj.client.getPlayerName());
	 %damageType = %this.DirectDamageType;
	 %scale = getWord(%obj.getScale(), 2);
   	 %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;

	 %newDirect = %directDamage + 65;

	 %col.damage(%obj,%pos,%newDirect,%damageType);
      }
      else
      {
	 parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
      }
   }
   else
   {
      parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
   }
}